(function () {
	'use strict';

	var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

	function createCommonjsModule(fn) {
	  var module = { exports: {} };
		return fn(module, module.exports), module.exports;
	}

	var browserPolyfill = createCommonjsModule(function (module, exports) {
	(function (global, factory) {
	  {
	    factory(module);
	  }
	})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : commonjsGlobal, function (module) {

	  if (typeof browser === "undefined" || Object.getPrototypeOf(browser) !== Object.prototype) {
	    const CHROME_SEND_MESSAGE_CALLBACK_NO_RESPONSE_MESSAGE = "The message port closed before a response was received.";
	    const SEND_RESPONSE_DEPRECATION_WARNING = "Returning a Promise is the preferred way to send a reply from an onMessage/onMessageExternal listener, as the sendResponse will be removed from the specs (See https://developer.mozilla.org/docs/Mozilla/Add-ons/WebExtensions/API/runtime/onMessage)"; // Wrapping the bulk of this polyfill in a one-time-use function is a minor
	    // optimization for Firefox. Since Spidermonkey does not fully parse the
	    // contents of a function until the first time it's called, and since it will
	    // never actually need to be called, this allows the polyfill to be included
	    // in Firefox nearly for free.

	    const wrapAPIs = extensionAPIs => {
	      // NOTE: apiMetadata is associated to the content of the api-metadata.json file
	      // at build time by replacing the following "include" with the content of the
	      // JSON file.
	      const apiMetadata = {
	        "alarms": {
	          "clear": {
	            "minArgs": 0,
	            "maxArgs": 1
	          },
	          "clearAll": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "get": {
	            "minArgs": 0,
	            "maxArgs": 1
	          },
	          "getAll": {
	            "minArgs": 0,
	            "maxArgs": 0
	          }
	        },
	        "bookmarks": {
	          "create": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "get": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getChildren": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getRecent": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getSubTree": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getTree": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "move": {
	            "minArgs": 2,
	            "maxArgs": 2
	          },
	          "remove": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "removeTree": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "search": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "update": {
	            "minArgs": 2,
	            "maxArgs": 2
	          }
	        },
	        "browserAction": {
	          "disable": {
	            "minArgs": 0,
	            "maxArgs": 1,
	            "fallbackToNoCallback": true
	          },
	          "enable": {
	            "minArgs": 0,
	            "maxArgs": 1,
	            "fallbackToNoCallback": true
	          },
	          "getBadgeBackgroundColor": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getBadgeText": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getPopup": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getTitle": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "openPopup": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "setBadgeBackgroundColor": {
	            "minArgs": 1,
	            "maxArgs": 1,
	            "fallbackToNoCallback": true
	          },
	          "setBadgeText": {
	            "minArgs": 1,
	            "maxArgs": 1,
	            "fallbackToNoCallback": true
	          },
	          "setIcon": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "setPopup": {
	            "minArgs": 1,
	            "maxArgs": 1,
	            "fallbackToNoCallback": true
	          },
	          "setTitle": {
	            "minArgs": 1,
	            "maxArgs": 1,
	            "fallbackToNoCallback": true
	          }
	        },
	        "browsingData": {
	          "remove": {
	            "minArgs": 2,
	            "maxArgs": 2
	          },
	          "removeCache": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "removeCookies": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "removeDownloads": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "removeFormData": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "removeHistory": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "removeLocalStorage": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "removePasswords": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "removePluginData": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "settings": {
	            "minArgs": 0,
	            "maxArgs": 0
	          }
	        },
	        "commands": {
	          "getAll": {
	            "minArgs": 0,
	            "maxArgs": 0
	          }
	        },
	        "contextMenus": {
	          "remove": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "removeAll": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "update": {
	            "minArgs": 2,
	            "maxArgs": 2
	          }
	        },
	        "cookies": {
	          "get": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getAll": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getAllCookieStores": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "remove": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "set": {
	            "minArgs": 1,
	            "maxArgs": 1
	          }
	        },
	        "devtools": {
	          "inspectedWindow": {
	            "eval": {
	              "minArgs": 1,
	              "maxArgs": 2,
	              "singleCallbackArg": false
	            }
	          },
	          "panels": {
	            "create": {
	              "minArgs": 3,
	              "maxArgs": 3,
	              "singleCallbackArg": true
	            },
	            "elements": {
	              "createSidebarPane": {
	                "minArgs": 1,
	                "maxArgs": 1
	              }
	            }
	          }
	        },
	        "downloads": {
	          "cancel": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "download": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "erase": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getFileIcon": {
	            "minArgs": 1,
	            "maxArgs": 2
	          },
	          "open": {
	            "minArgs": 1,
	            "maxArgs": 1,
	            "fallbackToNoCallback": true
	          },
	          "pause": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "removeFile": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "resume": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "search": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "show": {
	            "minArgs": 1,
	            "maxArgs": 1,
	            "fallbackToNoCallback": true
	          }
	        },
	        "extension": {
	          "isAllowedFileSchemeAccess": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "isAllowedIncognitoAccess": {
	            "minArgs": 0,
	            "maxArgs": 0
	          }
	        },
	        "history": {
	          "addUrl": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "deleteAll": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "deleteRange": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "deleteUrl": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getVisits": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "search": {
	            "minArgs": 1,
	            "maxArgs": 1
	          }
	        },
	        "i18n": {
	          "detectLanguage": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getAcceptLanguages": {
	            "minArgs": 0,
	            "maxArgs": 0
	          }
	        },
	        "identity": {
	          "launchWebAuthFlow": {
	            "minArgs": 1,
	            "maxArgs": 1
	          }
	        },
	        "idle": {
	          "queryState": {
	            "minArgs": 1,
	            "maxArgs": 1
	          }
	        },
	        "management": {
	          "get": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getAll": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "getSelf": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "setEnabled": {
	            "minArgs": 2,
	            "maxArgs": 2
	          },
	          "uninstallSelf": {
	            "minArgs": 0,
	            "maxArgs": 1
	          }
	        },
	        "notifications": {
	          "clear": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "create": {
	            "minArgs": 1,
	            "maxArgs": 2
	          },
	          "getAll": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "getPermissionLevel": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "update": {
	            "minArgs": 2,
	            "maxArgs": 2
	          }
	        },
	        "pageAction": {
	          "getPopup": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getTitle": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "hide": {
	            "minArgs": 1,
	            "maxArgs": 1,
	            "fallbackToNoCallback": true
	          },
	          "setIcon": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "setPopup": {
	            "minArgs": 1,
	            "maxArgs": 1,
	            "fallbackToNoCallback": true
	          },
	          "setTitle": {
	            "minArgs": 1,
	            "maxArgs": 1,
	            "fallbackToNoCallback": true
	          },
	          "show": {
	            "minArgs": 1,
	            "maxArgs": 1,
	            "fallbackToNoCallback": true
	          }
	        },
	        "permissions": {
	          "contains": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getAll": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "remove": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "request": {
	            "minArgs": 1,
	            "maxArgs": 1
	          }
	        },
	        "runtime": {
	          "getBackgroundPage": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "getPlatformInfo": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "openOptionsPage": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "requestUpdateCheck": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "sendMessage": {
	            "minArgs": 1,
	            "maxArgs": 3
	          },
	          "sendNativeMessage": {
	            "minArgs": 2,
	            "maxArgs": 2
	          },
	          "setUninstallURL": {
	            "minArgs": 1,
	            "maxArgs": 1
	          }
	        },
	        "sessions": {
	          "getDevices": {
	            "minArgs": 0,
	            "maxArgs": 1
	          },
	          "getRecentlyClosed": {
	            "minArgs": 0,
	            "maxArgs": 1
	          },
	          "restore": {
	            "minArgs": 0,
	            "maxArgs": 1
	          }
	        },
	        "storage": {
	          "local": {
	            "clear": {
	              "minArgs": 0,
	              "maxArgs": 0
	            },
	            "get": {
	              "minArgs": 0,
	              "maxArgs": 1
	            },
	            "getBytesInUse": {
	              "minArgs": 0,
	              "maxArgs": 1
	            },
	            "remove": {
	              "minArgs": 1,
	              "maxArgs": 1
	            },
	            "set": {
	              "minArgs": 1,
	              "maxArgs": 1
	            }
	          },
	          "managed": {
	            "get": {
	              "minArgs": 0,
	              "maxArgs": 1
	            },
	            "getBytesInUse": {
	              "minArgs": 0,
	              "maxArgs": 1
	            }
	          },
	          "sync": {
	            "clear": {
	              "minArgs": 0,
	              "maxArgs": 0
	            },
	            "get": {
	              "minArgs": 0,
	              "maxArgs": 1
	            },
	            "getBytesInUse": {
	              "minArgs": 0,
	              "maxArgs": 1
	            },
	            "remove": {
	              "minArgs": 1,
	              "maxArgs": 1
	            },
	            "set": {
	              "minArgs": 1,
	              "maxArgs": 1
	            }
	          }
	        },
	        "tabs": {
	          "captureVisibleTab": {
	            "minArgs": 0,
	            "maxArgs": 2
	          },
	          "create": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "detectLanguage": {
	            "minArgs": 0,
	            "maxArgs": 1
	          },
	          "discard": {
	            "minArgs": 0,
	            "maxArgs": 1
	          },
	          "duplicate": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "executeScript": {
	            "minArgs": 1,
	            "maxArgs": 2
	          },
	          "get": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getCurrent": {
	            "minArgs": 0,
	            "maxArgs": 0
	          },
	          "getZoom": {
	            "minArgs": 0,
	            "maxArgs": 1
	          },
	          "getZoomSettings": {
	            "minArgs": 0,
	            "maxArgs": 1
	          },
	          "goBack": {
	            "minArgs": 0,
	            "maxArgs": 1
	          },
	          "goForward": {
	            "minArgs": 0,
	            "maxArgs": 1
	          },
	          "highlight": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "insertCSS": {
	            "minArgs": 1,
	            "maxArgs": 2
	          },
	          "move": {
	            "minArgs": 2,
	            "maxArgs": 2
	          },
	          "query": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "reload": {
	            "minArgs": 0,
	            "maxArgs": 2
	          },
	          "remove": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "removeCSS": {
	            "minArgs": 1,
	            "maxArgs": 2
	          },
	          "sendMessage": {
	            "minArgs": 2,
	            "maxArgs": 3
	          },
	          "setZoom": {
	            "minArgs": 1,
	            "maxArgs": 2
	          },
	          "setZoomSettings": {
	            "minArgs": 1,
	            "maxArgs": 2
	          },
	          "update": {
	            "minArgs": 1,
	            "maxArgs": 2
	          }
	        },
	        "topSites": {
	          "get": {
	            "minArgs": 0,
	            "maxArgs": 0
	          }
	        },
	        "webNavigation": {
	          "getAllFrames": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "getFrame": {
	            "minArgs": 1,
	            "maxArgs": 1
	          }
	        },
	        "webRequest": {
	          "handlerBehaviorChanged": {
	            "minArgs": 0,
	            "maxArgs": 0
	          }
	        },
	        "windows": {
	          "create": {
	            "minArgs": 0,
	            "maxArgs": 1
	          },
	          "get": {
	            "minArgs": 1,
	            "maxArgs": 2
	          },
	          "getAll": {
	            "minArgs": 0,
	            "maxArgs": 1
	          },
	          "getCurrent": {
	            "minArgs": 0,
	            "maxArgs": 1
	          },
	          "getLastFocused": {
	            "minArgs": 0,
	            "maxArgs": 1
	          },
	          "remove": {
	            "minArgs": 1,
	            "maxArgs": 1
	          },
	          "update": {
	            "minArgs": 2,
	            "maxArgs": 2
	          }
	        }
	      };

	      if (Object.keys(apiMetadata).length === 0) {
	        throw new Error("api-metadata.json has not been included in browser-polyfill");
	      }
	      /**
	       * A WeakMap subclass which creates and stores a value for any key which does
	       * not exist when accessed, but behaves exactly as an ordinary WeakMap
	       * otherwise.
	       *
	       * @param {function} createItem
	       *        A function which will be called in order to create the value for any
	       *        key which does not exist, the first time it is accessed. The
	       *        function receives, as its only argument, the key being created.
	       */


	      class DefaultWeakMap extends WeakMap {
	        constructor(createItem, items = undefined) {
	          super(items);
	          this.createItem = createItem;
	        }

	        get(key) {
	          if (!this.has(key)) {
	            this.set(key, this.createItem(key));
	          }

	          return super.get(key);
	        }

	      }
	      /**
	       * Returns true if the given object is an object with a `then` method, and can
	       * therefore be assumed to behave as a Promise.
	       *
	       * @param {*} value The value to test.
	       * @returns {boolean} True if the value is thenable.
	       */


	      const isThenable = value => {
	        return value && typeof value === "object" && typeof value.then === "function";
	      };
	      /**
	       * Creates and returns a function which, when called, will resolve or reject
	       * the given promise based on how it is called:
	       *
	       * - If, when called, `chrome.runtime.lastError` contains a non-null object,
	       *   the promise is rejected with that value.
	       * - If the function is called with exactly one argument, the promise is
	       *   resolved to that value.
	       * - Otherwise, the promise is resolved to an array containing all of the
	       *   function's arguments.
	       *
	       * @param {object} promise
	       *        An object containing the resolution and rejection functions of a
	       *        promise.
	       * @param {function} promise.resolve
	       *        The promise's resolution function.
	       * @param {function} promise.rejection
	       *        The promise's rejection function.
	       * @param {object} metadata
	       *        Metadata about the wrapped method which has created the callback.
	       * @param {integer} metadata.maxResolvedArgs
	       *        The maximum number of arguments which may be passed to the
	       *        callback created by the wrapped async function.
	       *
	       * @returns {function}
	       *        The generated callback function.
	       */


	      const makeCallback = (promise, metadata) => {
	        return (...callbackArgs) => {
	          if (extensionAPIs.runtime.lastError) {
	            promise.reject(extensionAPIs.runtime.lastError);
	          } else if (metadata.singleCallbackArg || callbackArgs.length <= 1 && metadata.singleCallbackArg !== false) {
	            promise.resolve(callbackArgs[0]);
	          } else {
	            promise.resolve(callbackArgs);
	          }
	        };
	      };

	      const pluralizeArguments = numArgs => numArgs == 1 ? "argument" : "arguments";
	      /**
	       * Creates a wrapper function for a method with the given name and metadata.
	       *
	       * @param {string} name
	       *        The name of the method which is being wrapped.
	       * @param {object} metadata
	       *        Metadata about the method being wrapped.
	       * @param {integer} metadata.minArgs
	       *        The minimum number of arguments which must be passed to the
	       *        function. If called with fewer than this number of arguments, the
	       *        wrapper will raise an exception.
	       * @param {integer} metadata.maxArgs
	       *        The maximum number of arguments which may be passed to the
	       *        function. If called with more than this number of arguments, the
	       *        wrapper will raise an exception.
	       * @param {integer} metadata.maxResolvedArgs
	       *        The maximum number of arguments which may be passed to the
	       *        callback created by the wrapped async function.
	       *
	       * @returns {function(object, ...*)}
	       *       The generated wrapper function.
	       */


	      const wrapAsyncFunction = (name, metadata) => {
	        return function asyncFunctionWrapper(target, ...args) {
	          if (args.length < metadata.minArgs) {
	            throw new Error(`Expected at least ${metadata.minArgs} ${pluralizeArguments(metadata.minArgs)} for ${name}(), got ${args.length}`);
	          }

	          if (args.length > metadata.maxArgs) {
	            throw new Error(`Expected at most ${metadata.maxArgs} ${pluralizeArguments(metadata.maxArgs)} for ${name}(), got ${args.length}`);
	          }

	          return new Promise((resolve, reject) => {
	            if (metadata.fallbackToNoCallback) {
	              // This API method has currently no callback on Chrome, but it return a promise on Firefox,
	              // and so the polyfill will try to call it with a callback first, and it will fallback
	              // to not passing the callback if the first call fails.
	              try {
	                target[name](...args, makeCallback({
	                  resolve,
	                  reject
	                }, metadata));
	              } catch (cbError) {
	                console.warn(`${name} API method doesn't seem to support the callback parameter, ` + "falling back to call it without a callback: ", cbError);
	                target[name](...args); // Update the API method metadata, so that the next API calls will not try to
	                // use the unsupported callback anymore.

	                metadata.fallbackToNoCallback = false;
	                metadata.noCallback = true;
	                resolve();
	              }
	            } else if (metadata.noCallback) {
	              target[name](...args);
	              resolve();
	            } else {
	              target[name](...args, makeCallback({
	                resolve,
	                reject
	              }, metadata));
	            }
	          });
	        };
	      };
	      /**
	       * Wraps an existing method of the target object, so that calls to it are
	       * intercepted by the given wrapper function. The wrapper function receives,
	       * as its first argument, the original `target` object, followed by each of
	       * the arguments passed to the original method.
	       *
	       * @param {object} target
	       *        The original target object that the wrapped method belongs to.
	       * @param {function} method
	       *        The method being wrapped. This is used as the target of the Proxy
	       *        object which is created to wrap the method.
	       * @param {function} wrapper
	       *        The wrapper function which is called in place of a direct invocation
	       *        of the wrapped method.
	       *
	       * @returns {Proxy<function>}
	       *        A Proxy object for the given method, which invokes the given wrapper
	       *        method in its place.
	       */


	      const wrapMethod = (target, method, wrapper) => {
	        return new Proxy(method, {
	          apply(targetMethod, thisObj, args) {
	            return wrapper.call(thisObj, target, ...args);
	          }

	        });
	      };

	      let hasOwnProperty = Function.call.bind(Object.prototype.hasOwnProperty);
	      /**
	       * Wraps an object in a Proxy which intercepts and wraps certain methods
	       * based on the given `wrappers` and `metadata` objects.
	       *
	       * @param {object} target
	       *        The target object to wrap.
	       *
	       * @param {object} [wrappers = {}]
	       *        An object tree containing wrapper functions for special cases. Any
	       *        function present in this object tree is called in place of the
	       *        method in the same location in the `target` object tree. These
	       *        wrapper methods are invoked as described in {@see wrapMethod}.
	       *
	       * @param {object} [metadata = {}]
	       *        An object tree containing metadata used to automatically generate
	       *        Promise-based wrapper functions for asynchronous. Any function in
	       *        the `target` object tree which has a corresponding metadata object
	       *        in the same location in the `metadata` tree is replaced with an
	       *        automatically-generated wrapper function, as described in
	       *        {@see wrapAsyncFunction}
	       *
	       * @returns {Proxy<object>}
	       */

	      const wrapObject = (target, wrappers = {}, metadata = {}) => {
	        let cache = Object.create(null);
	        let handlers = {
	          has(proxyTarget, prop) {
	            return prop in target || prop in cache;
	          },

	          get(proxyTarget, prop, receiver) {
	            if (prop in cache) {
	              return cache[prop];
	            }

	            if (!(prop in target)) {
	              return undefined;
	            }

	            let value = target[prop];

	            if (typeof value === "function") {
	              // This is a method on the underlying object. Check if we need to do
	              // any wrapping.
	              if (typeof wrappers[prop] === "function") {
	                // We have a special-case wrapper for this method.
	                value = wrapMethod(target, target[prop], wrappers[prop]);
	              } else if (hasOwnProperty(metadata, prop)) {
	                // This is an async method that we have metadata for. Create a
	                // Promise wrapper for it.
	                let wrapper = wrapAsyncFunction(prop, metadata[prop]);
	                value = wrapMethod(target, target[prop], wrapper);
	              } else {
	                // This is a method that we don't know or care about. Return the
	                // original method, bound to the underlying object.
	                value = value.bind(target);
	              }
	            } else if (typeof value === "object" && value !== null && (hasOwnProperty(wrappers, prop) || hasOwnProperty(metadata, prop))) {
	              // This is an object that we need to do some wrapping for the children
	              // of. Create a sub-object wrapper for it with the appropriate child
	              // metadata.
	              value = wrapObject(value, wrappers[prop], metadata[prop]);
	            } else if (hasOwnProperty(metadata, "*")) {
	              // Wrap all properties in * namespace.
	              value = wrapObject(value, wrappers[prop], metadata["*"]);
	            } else {
	              // We don't need to do any wrapping for this property,
	              // so just forward all access to the underlying object.
	              Object.defineProperty(cache, prop, {
	                configurable: true,
	                enumerable: true,

	                get() {
	                  return target[prop];
	                },

	                set(value) {
	                  target[prop] = value;
	                }

	              });
	              return value;
	            }

	            cache[prop] = value;
	            return value;
	          },

	          set(proxyTarget, prop, value, receiver) {
	            if (prop in cache) {
	              cache[prop] = value;
	            } else {
	              target[prop] = value;
	            }

	            return true;
	          },

	          defineProperty(proxyTarget, prop, desc) {
	            return Reflect.defineProperty(cache, prop, desc);
	          },

	          deleteProperty(proxyTarget, prop) {
	            return Reflect.deleteProperty(cache, prop);
	          }

	        }; // Per contract of the Proxy API, the "get" proxy handler must return the
	        // original value of the target if that value is declared read-only and
	        // non-configurable. For this reason, we create an object with the
	        // prototype set to `target` instead of using `target` directly.
	        // Otherwise we cannot return a custom object for APIs that
	        // are declared read-only and non-configurable, such as `chrome.devtools`.
	        //
	        // The proxy handlers themselves will still use the original `target`
	        // instead of the `proxyTarget`, so that the methods and properties are
	        // dereferenced via the original targets.

	        let proxyTarget = Object.create(target);
	        return new Proxy(proxyTarget, handlers);
	      };
	      /**
	       * Creates a set of wrapper functions for an event object, which handles
	       * wrapping of listener functions that those messages are passed.
	       *
	       * A single wrapper is created for each listener function, and stored in a
	       * map. Subsequent calls to `addListener`, `hasListener`, or `removeListener`
	       * retrieve the original wrapper, so that  attempts to remove a
	       * previously-added listener work as expected.
	       *
	       * @param {DefaultWeakMap<function, function>} wrapperMap
	       *        A DefaultWeakMap object which will create the appropriate wrapper
	       *        for a given listener function when one does not exist, and retrieve
	       *        an existing one when it does.
	       *
	       * @returns {object}
	       */


	      const wrapEvent = wrapperMap => ({
	        addListener(target, listener, ...args) {
	          target.addListener(wrapperMap.get(listener), ...args);
	        },

	        hasListener(target, listener) {
	          return target.hasListener(wrapperMap.get(listener));
	        },

	        removeListener(target, listener) {
	          target.removeListener(wrapperMap.get(listener));
	        }

	      }); // Keep track if the deprecation warning has been logged at least once.


	      let loggedSendResponseDeprecationWarning = false;
	      const onMessageWrappers = new DefaultWeakMap(listener => {
	        if (typeof listener !== "function") {
	          return listener;
	        }
	        /**
	         * Wraps a message listener function so that it may send responses based on
	         * its return value, rather than by returning a sentinel value and calling a
	         * callback. If the listener function returns a Promise, the response is
	         * sent when the promise either resolves or rejects.
	         *
	         * @param {*} message
	         *        The message sent by the other end of the channel.
	         * @param {object} sender
	         *        Details about the sender of the message.
	         * @param {function(*)} sendResponse
	         *        A callback which, when called with an arbitrary argument, sends
	         *        that value as a response.
	         * @returns {boolean}
	         *        True if the wrapped listener returned a Promise, which will later
	         *        yield a response. False otherwise.
	         */


	        return function onMessage(message, sender, sendResponse) {
	          let didCallSendResponse = false;
	          let wrappedSendResponse;
	          let sendResponsePromise = new Promise(resolve => {
	            wrappedSendResponse = function (response) {
	              if (!loggedSendResponseDeprecationWarning) {
	                console.warn(SEND_RESPONSE_DEPRECATION_WARNING, new Error().stack);
	                loggedSendResponseDeprecationWarning = true;
	              }

	              didCallSendResponse = true;
	              resolve(response);
	            };
	          });
	          let result;

	          try {
	            result = listener(message, sender, wrappedSendResponse);
	          } catch (err) {
	            result = Promise.reject(err);
	          }

	          const isResultThenable = result !== true && isThenable(result); // If the listener didn't returned true or a Promise, or called
	          // wrappedSendResponse synchronously, we can exit earlier
	          // because there will be no response sent from this listener.

	          if (result !== true && !isResultThenable && !didCallSendResponse) {
	            return false;
	          } // A small helper to send the message if the promise resolves
	          // and an error if the promise rejects (a wrapped sendMessage has
	          // to translate the message into a resolved promise or a rejected
	          // promise).


	          const sendPromisedResult = promise => {
	            promise.then(msg => {
	              // send the message value.
	              sendResponse(msg);
	            }, error => {
	              // Send a JSON representation of the error if the rejected value
	              // is an instance of error, or the object itself otherwise.
	              let message;

	              if (error && (error instanceof Error || typeof error.message === "string")) {
	                message = error.message;
	              } else {
	                message = "An unexpected error occurred";
	              }

	              sendResponse({
	                __mozWebExtensionPolyfillReject__: true,
	                message
	              });
	            }).catch(err => {
	              // Print an error on the console if unable to send the response.
	              console.error("Failed to send onMessage rejected reply", err);
	            });
	          }; // If the listener returned a Promise, send the resolved value as a
	          // result, otherwise wait the promise related to the wrappedSendResponse
	          // callback to resolve and send it as a response.


	          if (isResultThenable) {
	            sendPromisedResult(result);
	          } else {
	            sendPromisedResult(sendResponsePromise);
	          } // Let Chrome know that the listener is replying.


	          return true;
	        };
	      });

	      const wrappedSendMessageCallback = ({
	        reject,
	        resolve
	      }, reply) => {
	        if (extensionAPIs.runtime.lastError) {
	          // Detect when none of the listeners replied to the sendMessage call and resolve
	          // the promise to undefined as in Firefox.
	          // See https://github.com/mozilla/webextension-polyfill/issues/130
	          if (extensionAPIs.runtime.lastError.message === CHROME_SEND_MESSAGE_CALLBACK_NO_RESPONSE_MESSAGE) {
	            resolve();
	          } else {
	            reject(extensionAPIs.runtime.lastError);
	          }
	        } else if (reply && reply.__mozWebExtensionPolyfillReject__) {
	          // Convert back the JSON representation of the error into
	          // an Error instance.
	          reject(new Error(reply.message));
	        } else {
	          resolve(reply);
	        }
	      };

	      const wrappedSendMessage = (name, metadata, apiNamespaceObj, ...args) => {
	        if (args.length < metadata.minArgs) {
	          throw new Error(`Expected at least ${metadata.minArgs} ${pluralizeArguments(metadata.minArgs)} for ${name}(), got ${args.length}`);
	        }

	        if (args.length > metadata.maxArgs) {
	          throw new Error(`Expected at most ${metadata.maxArgs} ${pluralizeArguments(metadata.maxArgs)} for ${name}(), got ${args.length}`);
	        }

	        return new Promise((resolve, reject) => {
	          const wrappedCb = wrappedSendMessageCallback.bind(null, {
	            resolve,
	            reject
	          });
	          args.push(wrappedCb);
	          apiNamespaceObj.sendMessage(...args);
	        });
	      };

	      const staticWrappers = {
	        runtime: {
	          onMessage: wrapEvent(onMessageWrappers),
	          onMessageExternal: wrapEvent(onMessageWrappers),
	          sendMessage: wrappedSendMessage.bind(null, "sendMessage", {
	            minArgs: 1,
	            maxArgs: 3
	          })
	        },
	        tabs: {
	          sendMessage: wrappedSendMessage.bind(null, "sendMessage", {
	            minArgs: 2,
	            maxArgs: 3
	          })
	        }
	      };
	      const settingMetadata = {
	        clear: {
	          minArgs: 1,
	          maxArgs: 1
	        },
	        get: {
	          minArgs: 1,
	          maxArgs: 1
	        },
	        set: {
	          minArgs: 1,
	          maxArgs: 1
	        }
	      };
	      apiMetadata.privacy = {
	        network: {
	          "*": settingMetadata
	        },
	        services: {
	          "*": settingMetadata
	        },
	        websites: {
	          "*": settingMetadata
	        }
	      };
	      return wrapObject(extensionAPIs, staticWrappers, apiMetadata);
	    };

	    if (typeof chrome != "object" || !chrome || !chrome.runtime || !chrome.runtime.id) {
	      throw new Error("This script should only be loaded in a browser extension.");
	    } // The build process adds a UMD wrapper around this file, which makes the
	    // `module` variable available.


	    module.exports = wrapAPIs(chrome);
	  } else {
	    module.exports = browser;
	  }
	});

	});

	/**
	 * @function
	 * @param {object} site
	 * @param {string} site.name
	 * @param {string} site.host
	 * @returns {object}
	 * @description returns an object containing the host and name of the given site.
	 * Example: https://example.com/fragment returns {name: "example", host: "www.example.com"} */
	function parseUrl(site) {
	  let host = site.includes("http") ? site.split("/")[2] : site.split("/")[0];
	  let name = host.includes("www") ? host.split(".")[1] : host.split(".")[0];
	  return { host: host, name: name };
	}

	/**
	 * @function
	 * @returns {object} date
	 * @description returns a new object containing a string with the date at time of function call,
	 * as well as numbers for hours, minutes, seconds and milliseconds, as well as a timestamp for use in
	 * Firestore document creation. */
	function makeDate() {
	  const options = {
	    weekday: "long",
	    year: "numeric",
	    month: "long",
	    day: "numeric",
	  };
	  const date = new Date();
	  return {
	    dateString: date.toLocaleDateString("en-US", options),
	    milliseconds: date.getMilliseconds(),
	    minutes: date.getMinutes(),
	    seconds: date.getSeconds(),
	    timestamp: date.getTime(),
	    hours: date.getHours(),
	  };
	}

	/**
	 * @param {number} milliseconds
	 * @returns {string} time
	 * @description Parses a given value of milliseconds into a short human-readable string.
	 * This function should be used only when counting up.
	 * For values greater than 60 seconds, the string value will be rounded up
	 * to the nearest minute. (eg: 1m). For values lesser than or equal to 60 seconds,
	 * the string value will be in seconds.
	 * For a long string version, use parseTimerDownLong. */
	function parseTimerDown(milliseconds) {
	  let seconds = milliseconds / 1000;
	  if (seconds <= 30) {
	    return `${seconds}s`;
	  } else if (seconds >= 31 && seconds <= 59) {
	    return "1m";
	  } else if (seconds >= 60) {
	    let minutes = seconds / 60;
	    minutes = Math.ceil(minutes);
	    return `${minutes}m`;
	  }
	}

	const parseTime = {
	  toHumanReadableArray: (time) => {
	    return [ Math.floor(time / 60 / 1000), (time / 1000) % 60 ];
	  },

	  toSystem: (time) => {
	    return 1000 * (time.min * 60 + time.sec);
	  },
	};

	const learningSites = [
	  {name: "codecademy", host: "www.codecademy.com"},
	  {name: "sololearn", host: "www.sololearn.com"},
	  {name: "udemy", host: "www.udemy.com"},
	];

	const participantResource = {name: "codecademy", host: "www.codecademy.com"};
	// export const participantResource = {name: "sololearn", host: "www.sololearn.com"}
	// export const participantResource = {name: "udemy", host: "www.udemy.com"}

	const storage = browserPolyfill.storage.local;

	/**
	 * @function
	 * @description Clears all stored data in browser storage. */
	function clearStorage() {
	  storage.clear();
	}

	/**
	 * @function
	 * @description Inverts the state of the "toggled" variable in storage
	 * that determines whether or not a user should be redirected.
	 * redirectionToggled is a settings parameter changed by the user. */

	function toggleRedirection() {
	  storage.get("toggled").then((data) => {
	    storage.set({ toggled: !data.toggled });
	  });
	}

	/**
	 * @async @function
	 * @returns {object} userData that includes a list of procrastination websites as defined by the user, as well as the user ID.
	 * @description Returns the user ID and a list of procrastination websites wrapped in an object. */
	async function getUserData() {
	  const result = await storage.get(["list", "uid"]);
	  return result;
	}

	/**
	 * @async @function
	 * @returns {Boolean} Determines whether user should be redirected.
	 * @description Returns a boolean value indicating whether user should be redirected.
	 * redirectionToggled is a settings parameter changed by the user. */
	async function getRedirectionToggled() {
	  const result = await storage.get("toggled");
	  return result.toggled;
	}

	/**
	 * @function
	 * @param {object[]} list
	 * @param {string} list[].name
	 * @param {string} list[].id
	 * @description Sets the list of procrastination websites in storage. */
	function setList(list) {
	  storage.set({ list: list });
	}

	/**
	 * @async @function
	 * @returns {object[]} list
	 * @description returns the list of procrastination websites from storage.*/
	async function getList() {
	  const result = await storage.get("list");
	  return result.list;
	}

	/**
	 * @function
	 * @param {string} uid
	 * @description sets the user ID in storage. */
	function setUid(uid) {
	  storage.set({ uid: uid });
	}

	/**
	 * @async @function
	 * @returns {string} User ID
	 * @description returns the user ID from storage. */
	async function getUid() {
	  const result = await storage.get("uid");
	  return result.uid;
	}

	/**
	 * @function
	 * @param {object} origin
	 * @param {string} origin.url
	 * @param {number} origin.tabId
	 * @description sets the origin tabID and url in storage for later reference.
	 * The origin object is tied to the website from which the user was intercepted by Aiki3 */
	function setOrigin(origin) {
	  storage.set({ origin: origin });
	}

	/**
	 * @async @function
	 * @returns {object} origin
	 * @description returns the origin tabID and url in storage.
	 *  The origin object is tied to the website from which the user was intercepted by Aiki3 */
	async function getOrigin() {
	  const result = await storage.get("origin");
	  return result.origin;
	}

	/**
	 * @function
	 * @description removes the origin variable from storage.
	 *  The origin object is tied to the website from which the user was intercepted by Aiki3 */
	function removeOrigin() {
	  storage.remove("origin");
	}

	async function setLearningUri(uri) {
	  console.log(uri, "HERE");
	  if (uri) {
	    storage.set({ learningUri: uri });
	  } else {
	    storage.set({ learningUri: "https://itu.dk/" });
	  }
	}

	async function getLearningUri() {
	  let result = await storage.get("learningUri");
	  console.log(result);
	  if (result.learningUri) {
	    return result.learningUri;
	  } //return await browser.management.getSelf().optionsUrl;
	}

	// function setLearningUri (uri){
	//   storage.set({learningUri: uri});
	// }

	/**
	 * @async @function
	 * @returns {number} learningTime
	 * @description returns a userdefined amount of miliseconds
	 * before they can continue to their origin procrastination website. */
	async function getLearningTime() {
	  const result = await storage.get("learningTime");
	  return result.learningTime;
	}

	/**
	 * @function
	 * @param {number} time
	 * @description sets the amount of time before a user is allowed to
	 * continue to the origin procrastination website. */
	function setLearningTime(time) {
	  storage.set({ learningTime: time });
	}

	/**
	 * @async @function
	 * @returns {number} rewardTime
	 * @description returns the userdefined amount of miliseconds the user is allowed to spend on
	 * procrastination websites before interception is turned back on. */
	async function getRewardTime() {
	  const result = await storage.get("rewardTime");
	  return result.rewardTime;
	}

	/**
	 * @function
	 * @param {number} time
	 * @description sets in storage the userdefined amount of miliseconds the user is allowed
	 * to spend on procrastination websites before interception is turned back on. */
	function setRewardTime(time) {
	  storage.set({ rewardTime: time });
	}

	/**
	 * @async @function
	 * @returns {object} userTimes
	 * @description returns an object containing the time-related
	 * values set by the user: rewardTime and learningTime. */
	async function getUserTimes() {
	  const result = await storage.get(["rewardTime", "learningTime"]);
	  return result;
	}

	/**
	 * @description Initializes the time settings in storage upon app installation. */
	function userTimeInit() {
	  setLearningTime({ min: 5, sec: 0 });
	  setRewardTime({ min: 5, sec: 0 });
	}

	/**
	 * @async @function
	 * @param {Boolean} state
	 * @description sets in storage whether user should be redirected.
	 * shouldRedirect is defined by the application when the user has earned
	 * procrastination time, and again when this expires. */
	async function setShouldRedirect(state) {
	  storage.set({ shouldRedirect: state });
	}

	/**
	 * @async @function
	 * @returns {Boolean} shouldRedirect
	 * @description returns the state of whether user should be redirected.
	 * shouldRedirect is defined by the application when the user has earned
	 * procrastination time, and again when this expires. */
	async function getShouldRedirect() {
	  const result = await storage.get("shouldRedirect");
	  return result.shouldRedirect;
	}

	async function storeSession(data) {
	  const { statsDate } = await storage.get("statsDate");
	  await checkDate(statsDate);
	  const { sessionData } = await storage.get("sessionData");
	  let newData = sessionData;
	  if (
	    !newData.hasOwnProperty("procrastinationDuration") ||
	    newData.procrastinationDuration === NaN
	  ) {
	    newData.procrastinationDuration = 0;
	  }
	  if (
	    !newData.hasOwnProperty("learningDuration") ||
	    newData.learningDuration === NaN
	  ) {
	    newData.learningDuration = 0;
	  }

	  for (const key in data) {
	    if (key === getLearningUri()) {
	      newData.learningDuration += data[key];
	    } else if (!["chromeInactive", "chromeActive"].includes(key)) {
	      newData[key] = sessionData.hasOwnProperty(key)
	        ? sessionData[key] + data[key]
	        : data[key];
	      newData.procrastinationDuration += data[key];
	    }
	  }
	  storage.set({ sessionData: newData });
	}

	async function checkDate(statsDate) {
	  const date = new Date().toDateString();
	  console.log("inc: ", statsDate, "date: ", date);
	  if (statsDate !== date) {
	    console.log("Rolling over date");
	    await overWriteYesterday();
	    await storage.set({ snoozeCount: 0 });
	    await storage.set({ completedCount: 0 });
	    await storage.set({ skipCount: 0 });
	    await storage.set({
	      sessionData: { procrastinationDuration: 0, learningDuration: 0 },
	    });
	    await storage.set({ statsDate: date });
	  }
	}

	async function incrSnoozeCount() {
	  const { statsDate, snoozeCount } = await storage.get([
	    "snoozeCount",
	    "statsDate",
	  ]);
	  await checkDate(statsDate);
	  storage.set({ snoozeCount: snoozeCount + 1 });
	}

	async function incrContinueCount() {
	  const { completedCount, statsDate } = await storage.get([
	    "completedCount",
	    "statsDate",
	  ]);
	  await checkDate(statsDate);
	  storage.set({ completedCount: completedCount + 1 });
	}

	async function incrSkipCount() {
	  const { skipCount, statsDate } = await storage.get([
	    "skipCount",
	    "statsDate",
	  ]);
	  await checkDate(statsDate);
	  storage.set({ skipCount: skipCount + 1 });
	}

	async function getAllStats() {
	  const result = await storage.get([
	    "sessionData",
	    "skipCount",
	    "completedCount",
	    "snoozeCount",
	    "yesterday",
	    "history",
	  ]);
	  return result;
	}

	// async function testStatsFlow() {
	//   await storage.set({ statsDate: new Date(2021, 5, 9).toDateString() });
	//   console.log(await storage.get("statsDate"))
	// await storeSession({ theguardian: 60, sololearn: 60 });
	// await incrContinueCount();
	// await storage.set({ statsDate: new Date(2021, 5, 10).dateString });
	// await storeSession({ theguardian: 60, sololearn: 60 });
	// await incrContinueCount();
	// await storage.set({ statsDate: new Date(2021, 5, 11).dateString });
	// await storeSession({ theguardian: 60, sololearn: 60 });
	// await incrContinueCount();
	// }

	// testStatsFlow();

	function initializeStats() {
	  storage.set({
	    sessionData: { procrastinationDuration: 0, learningDuration: 0 },
	  });
	  storage.set({ skipCount: 0 });
	  storage.set({ completedCount: 0 });
	  storage.set({ snoozeCount: 0 });
	  storage.set({
	    history: {
	      sessionData: { procrastinationDuration: 0, learningDuration: 0 },
	      completedCount: 0,
	      skipCount: 0,
	      snoozeCount: 0,
	    },
	  });
	  storage.set({
	    yesterday: {
	      sessionData: { procrastinationDuration: 0, learningDuration: 0 },
	      skipCount: 0,
	      completedCount: 0,
	      snoozeCount: 0,
	    },
	  });
	}

	async function overWriteYesterday() {
	  await addToHistory();
	  const yesterday = await storage.get([
	    "sessionData",
	    "skipCount",
	    "completedCount",
	    "snoozeCount",
	  ]);
	  storage.set({
	    yesterday: yesterday,
	  });
	}

	async function addToHistory() {
	  let { yesterday, history } = await storage.get(["yesterday", "history"]);
	  if (!history.hasOwnProperty("skipCount") || history.skipCount === NaN)
	    history.skipCount = 0;
	  if (
	    !history.hasOwnProperty("completedCount") ||
	    history.completedCount === NaN
	  )
	    history.completedCount = 0;
	  if (!history.hasOwnProperty("snoozeCount") || history.snoozeCount === NaN)
	    history.snoozeCount = 0;
	  if (!history.hasOwnProperty("sessionData")) {
	    history.sessionData = { procrastinationDuration: 0, learningDuration: 0 };
	  } else if (
	    history.sessionData.procrastinationDuration === NaN ||
	    history.sessionData.learningDuration === NaN
	  ) {
	    history.sessionData = { procrastinationDuration: 0, learningDuration: 0 };
	  }
	  history.skipCount += yesterday.skipCount;
	  history.completedCount += yesterday.completedCount;
	  history.snoozeCount += yesterday.snoozeCount;
	  history.sessionData.procrastinationDuration +=
	    yesterday.sessionData.procrastinationDuration;
	  history.sessionData.learningDuration +=
	    yesterday.sessionData.learningDuration;
	  storage.set({ history: history });
	}

	function setActiveTimeFrom(value) {
	  storage.set({ activeFrom: value });
	}
	async function getActiveTimeFrom() {
	  const { activeFrom } = await storage.get("activeFrom");
	  return activeFrom;
	}
	function setActiveTimeTo(value) {
	  storage.set({ activeTo: value });
	}
	async function getActiveTimeTo() {
	  const { activeTo } = await storage.get("activeTo");
	  return activeTo;
	}

	async function getAllActiveTimes() {
	  const result = await storage.get(["activeFrom", "activeTo"]);
	  return result;
	}

	function operatingHoursInit() {
	  setActiveTimeFrom({ hrs: 8, min: 0 });
	  setActiveTimeTo({ hrs: 21, min: 30 });
	}

	async function addBlockedTabs(tab) {
	  const { blockedTabs } = await storage.get("blockedTabs");
	  if (blockedTabs) {
	    if (!blockedTabs.includes(tab)) {
	      storage.set({ blockedTabs: [...blockedTabs, tab] });
	    }
	  } else {
	    storage.set({ blockedTabs: [tab] });
	  }
	}

	async function getBlockedTabs() {
	  const { blockedTabs } = await storage.get("blockedTabs");
	  if (blockedTabs) {
	    return blockedTabs;
	  } else return [];
	}

	function clearBlockedTabs() {
	  storage.remove("blockedTabs");
	}

	var storage$1 = {
	  timeSettings: {
	    getAll: getUserTimes,
	    init: userTimeInit,
	    learningTime: { get: getLearningTime, set: setLearningTime },
	    rewardTime: { get: getRewardTime, set: setRewardTime },
	  },
	  shouldRedirect: { get: getShouldRedirect, set: setShouldRedirect },
	  clearStorage,
	  getUserData,
	  origin: { get: getOrigin, set: setOrigin, remove: removeOrigin },
	  learningUri: { get: getLearningUri, set: setLearningUri },
	  list: { set: setList, get: getList },
	  uid: { set: setUid, get: getUid },
	  redirection: { toggle: toggleRedirection, get: getRedirectionToggled },
	  stats: {
	    storeSession: storeSession,
	    skip: incrSkipCount,
	    continue: incrContinueCount,
	    snooze: incrSnoozeCount,
	    getAll: getAllStats,
	    init: initializeStats,
	  },
	  operatingHours: {
	    from: { get: getActiveTimeFrom, set: setActiveTimeFrom },
	    to: { get: getActiveTimeTo, set: setActiveTimeTo },
	    getAll: getAllActiveTimes,
	    init: operatingHoursInit,
	  },
	  blockedTabs: {
	    get: getBlockedTabs,
	    add: addBlockedTabs,
	    clear: clearBlockedTabs,
	  },
	};

	function addLog () {
	  // 
	}

	var firebase = {
	  addLog,
	};

	let list;
	let user;
	let data = {
	  chromeActive: 0,
	  chromeInactive: 0,
	};
	let counterId;
	let loggerId;

	function intervalSetup() {
	  syncUser();
	  syncList();
	  startCounter();
	  startLogger();
	  addOnWindowsCloseListener();
	}

	async function counter() {
	  const window = await browserPolyfill.windows.getCurrent();
	  const views = chrome.extension.getViews({ type: "popup" });
	  if (window.focused || views.length > 0) {
	    data.chromeActive++;
	    const result = await browserPolyfill.tabs.query({
	      active: true,
	      currentWindow: true,
	    });
	    const name = parseUrl(result[0].url).name;
	    if (
	      list.includes(name) ||
	      learningSites.find((site) => site.name === name) !== undefined
	    ) {
	      data[name] = data[name] ? data[name] + 1 : 1;
	    }
	  } else {
	    data.chromeInactive++;
	  }
	}

	function logger() {
	  storeData(data);
	  resetData();
	}

	function startCounter() {
	  counterId = setInterval(counter, 1000); // 1 second
	}

	function stopCounter() {
	  clearInterval(counterId);
	}

	function startLogger() {
	  loggerId = setInterval(logger, 1000 * 60 * 5); // 5 minutes
	}

	function stopLogger() {
	  clearInterval(loggerId);
	}

	async function restartCounter() {
	  stopCounter();
	  await syncList();
	  startCounter();
	}

	async function restartLogger() {
	  stopLogger();
	  storeData(data);
	  resetData();
	  await syncUser();
	  startLogger();
	}

	async function syncUser() {
	  const result = await storage$1.uid.get();
	  user = result;
	}

	async function syncList() {
	  const result = await storage$1.list.get();
	  list = result ? result.map((item) => item.name) : [];
	}

	function storeData(data) {
	  if (user) {
	    storage$1.stats.storeSession(data);
	    const entry = { data: data, user: user, date: makeDate() };
	    firebase.addLog(entry, "session");
	  }
	}

	function resetData() {
	  data = {
	    chromeActive: 0,
	    chromeInactive: 0,
	  };
	}

	function addOnWindowsCloseListener() {
	  browserPolyfill.windows.onRemoved.addListener((details) => {
	    storeData(data);
	    resetData();
	  });
	}

	var intervals = {
	  intervalSetup,
	  counter: { start: startCounter, restart: restartCounter },
	  logger: { start: startLogger, restart: restartLogger },
	  addOnWindowsCloseListener,
	};

	//Functions to control the badge that appears on the extension icon in the chrome toolbar.
	 
	  /**
	  * @description Adds text to the badge.
	  * @param { String | number } value Should be less than 4 characters long.  */
	  function setText(value) {
	    browserPolyfill.browserAction.setBadgeText({text: `${value}`});
	  }

	  /**
	  * @description Changes the background colour of the badge to green.  */
	  function setBusy() {
	    browserPolyfill.browserAction.setBadgeBackgroundColor({color:'limegreen'});
	  }

	  /**
	  * @description Changes the background colour of the badge to blue.  */
	  function setDone() {
	    browserPolyfill.browserAction.setBadgeBackgroundColor({color:'deepskyblue'});
	  }

	  /**
	  * @description Removes the badge from the icon entirely.  */
	  function remove() {
	    browserPolyfill.browserAction.setBadgeText({text: ''});
	  }

	  var badge = {
	    setText, setBusy, setDone, remove
	  };

	let learningTimeRemaining = 0;
	let learningTimeIntervalRef;

	async function decrementLearningTime() {
	  if (await checkActive()) {
	    if (learningTimeRemaining > 0) {
	      learningTimeRemaining -= 1000;
	      badge.setText(parseTimerDown(learningTimeRemaining));
	    } else if (learningTimeRemaining < 0) {
	      learningTimeRemaining = 0;
	    } else {
	      startBonusTime();
	    }
	  }
	}

	async function startLearningSession() {
	  if (bonusTimeIntervalRef) stopBonusTime();
	  if (learningTimeIntervalRef) clearInterval(learningTimeIntervalRef);
	  badge.setBusy();
	  learningTimeRemaining = parseTime.toSystem(
	    await storage$1.timeSettings.learningTime.get()
	  );
	  badge.setText(parseTimerDown(learningTimeRemaining));
	  learningTimeIntervalRef = setInterval(decrementLearningTime, 1000);
	}

	function stopLearningSession() {
	  clearInterval(learningTimeIntervalRef);
	  learningTimeIntervalRef = undefined;
	  learningTimeRemaining = 0;
	  badge.remove();
	}

	let rewardTimeRemaining = 0;
	let rewardTimeIntervalRef;

	async function decrementRewardTime(callback) {
	  if (rewardTimeRemaining > 0) {
	    rewardTimeRemaining -= 1000;
	  } else if (rewardTimeRemaining < 0) {
	    rewardTimeRemaining = 0;
	  } else {
	    stopProcrastinationSession(callback);
	  }
	}

	async function startProcrastinationSession(callback, rewardTime) {
	  stopLearningSession();
	  stopBonusTime();
	  rewardTimeRemaining = rewardTime;
	  rewardTimeIntervalRef = setInterval(
	    () => decrementRewardTime(callback),
	    1000
	  );
	}

	function stopProcrastinationSession(callback) {
	  clearInterval(rewardTimeIntervalRef);
	  rewardTimeIntervalRef = undefined;
	  storage$1.shouldRedirect.set(true);
	  callback();
	}

	let bonusTime = 0;
	let bonusTimeIntervalRef;

	async function incrementBonusTime() {
	  if (await checkActive()) {
	    if (bonusTime >= 0) {
	      bonusTime += 1000;
	    } else {
	      bonusTime = 0;
	    }
	  }
	}

	function startBonusTime() {
	  if (bonusTimeIntervalRef) stopBonusTime();
	  badge.setDone();
	  badge.setText("Done");
	  clearInterval(learningTimeIntervalRef);
	  learningTimeIntervalRef = undefined;
	  bonusTimeIntervalRef = setInterval(incrementBonusTime, 1000);
	}

	function stopBonusTime() {
	  clearInterval(bonusTimeIntervalRef);
	  bonusTime = 0;
	  bonusTimeIntervalRef = undefined;
	}

	async function checkActive() {
	  const window = await browserPolyfill.windows.getCurrent();
	  const views = chrome.extension.getViews({ type: "popup" });
	  if (window.focused || views.length > 0) {
	    const currentTabs = await browserPolyfill.tabs.query({
	      active: true,
	      currentWindow: true,
	    });
	    if (currentTabs.length > 0) {
	      const current = currentTabs[0];
	      const origin = await storage$1.origin.get();
	      if (origin !== undefined) {
	        if (origin.tabId !== undefined) {
	          return current.id === origin.tabId;
	        }
	      }
	    }
	  } else {
	    return false;
	  }
	}

	function killAiki() {
	  clearInterval(rewardTimeIntervalRef);
	  rewardTimeIntervalRef = undefined;
	  stopBonusTime();
	  storage$1.shouldRedirect.set(true);
	  rewardTimeRemaining = 0;
	  bonusTime = 0;
	  learningTimeRemaining = 0;
	}

	function getTime() {
	  return {
	    bonusTime: bonusTime,
	    learningTimeRemaining: learningTimeRemaining,
	    rewardTimeRemaining: rewardTimeRemaining,
	  };
	}

	var timer = {
	  startLearningSession,
	  stopLearningSession,
	  startProcrastinationSession,
	  stopProcrastinationSession,
	  stopBonusTime,
	  getTime,
	  killAiki,
	};

	const l = console.log;

	let shouldShowWelcome = true;

	// async function addMirceaListener() {
	//   const url = learningSites.map((item) => {
	//     return { hostContains: `${item.name}.` };
	//   });
	//   const filter = { url: url };

	//   async function mirceaListener(details) {
	//     const user = await storage.uid.get();
	//     firebase.addLog(
	//       {
	//         user: user,
	//         event: `User went to ${details.url}`,
	//         details: details,
	//         date: makeDate(),
	//       },
	//       "learning_site"
	//     );
	//   }

	//   browser.webNavigation.onBeforeNavigate.addListener(mirceaListener, filter);
	// }

	async function createFilter() {
	  const procList = await storage$1.list.get();
	  const url = procList.map((item) => {
	    return { hostContains: `${item.name}.` };
	  });
	  const filter = { url: url };
	  return filter;
	}

	async function addNavigationListener() {
	  const filter = await createFilter();
	  browserPolyfill.webNavigation.onBeforeNavigate.addListener(redirect, filter);
	}

	async function removeNavigationListener() {
	  const filter = await createFilter();
	  browserPolyfill.webNavigation.onBeforeNavigate.removeListener(redirect, filter);
	}

	async function restartNavigationListener() {
	  await removeNavigationListener();
	  addNavigationListener();
	}

	function addTabChangeListener() {
	  browserPolyfill.tabs.onActivated.addListener(checkTabById);
	}

	function removeTabChangeListener() {
	  browserPolyfill.tabs.onActivated.removeListener(checkTabById);
	}

	async function windowChangeListener(windowId) {
	  if (windowId >= 0) {
	    try {
	      const tabs = await browserPolyfill.tabs.query({
	        active: true,
	        currentWindow: true,
	      });
	      if (tabs.length > 0) {
	        checkTab(tabs[0]);
	      }
	    } catch (error) {
	      // console.log(error);
	    }
	  }
	}

	function addWindowChangeListener() {
	  browserPolyfill.windows.onFocusChanged.addListener(windowChangeListener);
	}

	function removeWindowChangeListener() {
	  browserPolyfill.windows.onFocusChanged.removeListener(windowChangeListener);
	}

	async function restartWindowChangeListener() {
	  removeWindowChangeListener();
	  addWindowChangeListener();
	}

	async function restartTabChangeListener() {
	  removeTabChangeListener();
	  addTabChangeListener();
	}

	function addOriginUpdatedListener() {
	  browserPolyfill.tabs.onUpdated.addListener(originUpdatedListener);
	}

	function removeOriginUpdatedListener() {
	  "Removing originUpdatedListener";
	  browserPolyfill.tabs.onUpdated.removeListener(originUpdatedListener);
	}

	async function originUpdatedListener(details) {
	  const origin = await storage$1.origin.get();
	  if (origin) {
	    if (origin.tabId === details) {
	      const tab = await browserPolyfill.tabs.get(details);
	      l(tab);
	      if (tab.url.includes(participantResource.name)) {
	        storage$1.learningUri.set(tab.url);
	      }
	    }
	  }
	}

	/** #REDIRECT()#
	 * @async @function
	 * @description Checks if redirection should happen,
	 * then starts a learning session countdown,
	 * stores the origin tab and url in storage,
	 * then updates the tab with a pre-defined learning resourse url
	 * @param {object} details
	 * @param {string} details.url
	 * @param {number} details.tabId */
	async function redirect(details) {
	  if (await checkActiveTime()) {
	    if (details.frameId === 0 && !details.url.includes("auth")) {
	      const toggled = await storage$1.redirection.get();
	      const shouldRedirect = await storage$1.shouldRedirect.get();
	      if (toggled && shouldRedirect) {
	        l("ShouldRedirect", shouldRedirect);
	        const origin = await storage$1.origin.get();
	        l("Checking against this: ", origin);
	        if (origin) {
	          l(details);
	          addProcsiteLoadedListener();
	        } else {
	          timer.startLearningSession();
	          const learningUri = await storage$1.learningUri.get();
	          try {
	            await browserPolyfill.tabs.update(details.tabId, {
	              url: learningUri,
	            });

	            storage$1.origin.set({ url: details.url, tabId: details.tabId });
	            addRedirectionLog(
	              `Interception: instant redirection`,
	              parseUrl(details.url).name,
	              participantResource.name
	            );
	            addLearningSiteLoadedListener(details.tabId);
	          } catch (error) {
	            // console.log(error.message);
	          }
	          addOriginUpdatedListener(details.tabId);
	        }
	      }
	    }
	  }
	}

	async function checkActiveTime() {
	  const fromTime = await storage$1.operatingHours.from.get();
	  const toTime = await storage$1.operatingHours.to.get();
	  const date = makeDate();
	  if (date.hours < fromTime.hrs) {
	    return false;
	  } else if (date.hours === fromTime.hours && date.minutes < fromTime.minutes) {
	    return false;
	  }
	  if (date.hours > toTime.hrs) {
	    return false;
	  } else if (date.hours === toTime.hrs && date.minutes > toTime.min) {
	    return false;
	  }
	  return true;
	}

	function addOriginTabCloseListener() {
	  browserPolyfill.tabs.onRemoved.addListener(onOriginRemoved);
	}

	async function onOriginRemoved(details) {
	  const origin = await storage$1.origin.get();
	  if (origin) {
	    if (details === origin.tabId) {
	      l("Origin killed");
	      removeOriginUpdatedListener();
	      removeAllContentBlockers();
	      storage$1.origin.remove();
	      timer.stopBonusTime(); // Without this badge goes "Done". This is bad. Maybe I'll fix it later.
	      timer.stopLearningSession(); // This is fine
	      storage$1.shouldRedirect.set(true);
	    }
	  }
	}

	async function addLearningSiteLoadedListener() {
	  browserPolyfill.webNavigation.onCompleted.addListener(messageLearningResource, {
	    url: [{ hostContains: `.${participantResource.name}.` }],
	  });
	}

	function removeLearningSiteLoadedListener() {
	  l("Removing Leaning site loaded listener");
	  browserPolyfill.webNavigation.onCompleted.removeListener(messageLearningResource);
	  shouldShowWelcome = true;
	}

	async function messageLearningResource(details) {
	  try {
	    const origin = await storage$1.origin.get();
	    if (!origin || origin.tabId === details.tabId) {
	      const response = await browserPolyfill.tabs.sendMessage(details.tabId, {
	        action: "display: encouragement",
	        countdown: timer.getTime().learningTimeRemaining,
	        shouldShowWelcome: shouldShowWelcome,
	      });
	      shouldShowWelcome = false;
	      if ((await response.action) === "continue") {
	        // storage.learningUri.set(response.uri);
	        gotoOrigin("continue", response.source);
	        removeLearningSiteLoadedListener();
	      } else if ((await response.action) === "end injection") {
	        removeLearningSiteLoadedListener();
	      }
	    }
	  } catch (error) {
	    // console.log(error);
	  }
	}

	/** #CHECKCURRENTTAB()#
	@function
	@async
	@description Gets currently active tab and sends message to the content script if it
	is a procrastination website. */
	async function checkActiveTab() {
	  try {
	    const tabs = await browserPolyfill.tabs.query({
	      active: true,
	      currentWindow: true,
	    });
	    if (tabs.length > 0) {
	      const tab = tabs[0];
	      const tabSiteName = parseUrl(tab.url).name;
	      const procList = await storage$1.list.get();
	      const procListNames = procList.map((site) => site.name);
	      if (procListNames.includes(tabSiteName)) {
	        addRedirectionLog(
	          `Interception: initiating countdown`,
	          tabSiteName,
	          participantResource.name
	        );
	        const learningUri = await storage$1.learningUri.get();
	        talkToContent(tab.id, learningUri, tab.url);
	      }
	    }
	  } catch (error) {
	    // console.log(error.message);
	  }
	}

	async function checkTabById({ tabId }) {
	  try {
	    const tab = await browserPolyfill.tabs.get(tabId);
	    checkTab(tab);
	  } catch (error) {
	    // console.log(error.message);
	  }
	}
	// TODO: Rewrite these two functions ^ & v to 1 single function that checks if tab has url (if not, get it)

	/** #CHECKTAB()#
	 * @async
	 * @function
	 * @description Checks a tab against a list of websites defined as procrastination websites.
	 * If a tab's url is found in the list, it calls the redirect function using that tab's details.
	 * @param {object} tab
	 * @param {number} tab.frameId
	 * @param {string} tab.url
	 * @param {number} tab.id */
	async function checkTab(tab) {
	  const tabSiteName = parseUrl(tab.url).name;
	  const procList = await storage$1.list.get();
	  const procListNames = procList.map((site) => site.name);
	  if (procListNames.includes(tabSiteName)) {
	    const origin = await storage$1.origin.get();
	    if (origin) {
	      renderContentBlocker({ tabId: tab.id, frameId: 0 });
	    } else {
	      redirect({ frameId: 0, url: tab.url, tabId: tab.id });
	    }
	  }
	}

	/** #GOTOORIGIN()#
	 * @async
	 * @function
	 * @description Changes location of the tab registered as the tab
	 * that triggered a redirection from procrastination to learning site.
	 * The uri was saved upon redirection, and here restored in full in the same tab.
	 * Origin is an object of type: {integer: tabId, string: url} */
	async function gotoOrigin(event, source) {
	  await storage$1.stats[event]();
	  const origin = await storage$1.origin.get();
	  removeOriginUpdatedListener();
	  try {
	    const learningTab = await browserPolyfill.tabs.get(origin.tabId);
	    storage$1.learningUri.set(learningTab.url);
	  } catch (error) {
	    l(error);
	  }
	  await storage$1.shouldRedirect.set(false);
	  storage$1.origin.remove();
	  try {
	    await browserPolyfill.tabs.update(origin.tabId, { url: origin.url });
	    removeAllContentBlockers();
	    addRedirectionLog(
	      `Go to origin: ${event}, source: ${source}`,
	      participantResource.name,
	      parseUrl(origin.url).name
	    );
	  } catch (error) {
	    l(error);
	  }

	  const redirectionToggled = await storage$1.redirection.get();
	  if (redirectionToggled) {
	    const rewardTime = parseTime.toSystem(
	      await storage$1.timeSettings.rewardTime.get()
	    );
	    timer.startProcrastinationSession(checkActiveTab, rewardTime);
	  }
	}

	async function talkToContent(tabId, url, originUrl) {
	  try {
	    const result = await browserPolyfill.tabs.sendMessage(tabId, {
	      action: "display: snooze",
	      url: url,
	    });
	    if (result.action === "snooze") {
	      addRedirectionLog(
	        `Interception: snoozed`,
	        parseUrl(originUrl).name,
	        participantResource.name
	      );
	      storage$1.stats.snooze();
	      await storage$1.shouldRedirect.set(false);
	      timer.startProcrastinationSession(checkActiveTab, 60000);
	    } else {
	      addLearningSiteLoadedListener();
	      addRedirectionLog(
	        `Interception: auto resolve`,
	        parseUrl(originUrl).name,
	        participantResource.name
	      );
	      timer.startLearningSession();
	      storage$1.origin.set({ url: originUrl, tabId: tabId });
	      addOriginUpdatedListener(tabId);
	    }
	  } catch (error) {
	    // console.log(error.message);
	  }
	}

	async function addRedirectionLog(event, from, to) {
	  const user = await storage$1.uid.get();
	  const timeSettings = await storage$1.timeSettings.getAll();
	  firebase.addLog(
	    {
	      user: user,
	      event: event,
	      from: from,
	      to: to,
	      timeSettings: timeSettings,
	      date: makeDate(),
	    },
	    "redirection"
	  );
	}

	function renderContentBlocker(details) {
	  if (details.frameId === 0) {
	    removeProcsiteLoadedListener();
	    storage$1.blockedTabs.add(details.tabId);
	    try {
	      l("Sending block request to content");
	      browserPolyfill.tabs.sendMessage(details.tabId, {
	        action: "inject blocker",
	      });
	    } catch (error) {
	      // l(error);
	    }
	  }
	}

	function removeContentBlocker(tabId) {
	  l("Removing blocker on tab ", tabId);
	  try {
	    browserPolyfill.tabs.sendMessage(tabId, { action: "remove blocker" });
	  } catch (error) {
	    l(error);
	  }
	}

	async function removeAllContentBlockers() {
	  const blockedTabs = await storage$1.blockedTabs.get();
	  l("Blocked tabs: ", blockedTabs);
	  blockedTabs.forEach((tabId) => {
	    removeContentBlocker(tabId);
	  });
	  storage$1.blockedTabs.clear();
	}

	async function addProcsiteLoadedListener() {
	  l("Adding listener");
	  const filter = await createFilter();
	  l(filter);
	  browserPolyfill.webNavigation.onCompleted.addListener(renderContentBlocker, filter);
	}

	async function removeProcsiteLoadedListener() {
	  l("Removing listener");
	  browserPolyfill.webNavigation.onCompleted.removeListener(renderContentBlocker);
	}

	var redirection = {
	  navigationListener: {
	    start: addNavigationListener,
	    stop: removeNavigationListener,
	    restart: restartNavigationListener,
	  },
	  tabChangeListener: {
	    start: addTabChangeListener,
	    stop: removeTabChangeListener,
	    restart: restartTabChangeListener,
	  },
	  windowChangeListener: {
	    start: addWindowChangeListener,
	    stop: removeWindowChangeListener,
	    restart: restartWindowChangeListener,
	  },
	  gotoOrigin,
	  addOriginTabCloseListener,
	  removeLearningSiteLoadedListener,
	  checkActiveTab,
	  // addMirceaListener,
	};

	// Controls themes for the application. This is achieved by switching out global CSS variables in global.css
	const storage$2 = browserPolyfill.storage.local;

	// Variable that selects the root CSS file.
	const r = document.querySelector(":root");
	r.style;

	/**
	 * @function
	 * @param {string} theme
	 * @description  Sets the theme stored in local storage to the provided theme. */
	function setTheme(theme) {
	  storage$2.set({ theme: theme });
	}

	/* Add listener if the runtime is caused by initial installation of extension.
	If so, run initial setup */
	browserPolyfill.runtime.onInstalled.addListener(({ reason }) => {
	  if (reason === "install") {
	    installationSetup();
	  }
	});

	/**
	 * @async @function
	 * @description Runs the initial installation setup, creating values in storage used by the application,
	 * as well as automatically opening the settings page such that the user can input user ID and procrastination websites. */
	async function installationSetup() {
	  storage$1.clearStorage();
	  storage$1.stats.init();
	  storage$1.operatingHours.init();
	  setTheme("light");
	  storage$1.shouldRedirect.set(true);
	  storage$1.redirection.toggle();
	  storage$1.list.set([]);
	  storage$1.uid.set("");
	  storage$1.learningUri.set("https://itu.dk/");
	  storage$1.timeSettings.init();
	  const extRef = await browserPolyfill.management.getSelf();
	  browserPolyfill.tabs.create({
	    active: true,
	    url: extRef.optionsUrl,
	  });
	}

	/**
	 * @function
	 * @description runtime instance setup function.
	 * initiates setup of interval logging functionality, as well as adding navigation and tab change listeners. */
	async function setup() {
	  // redirection.addMirceaListener();
	  intervals.intervalSetup();
	  storage$1.shouldRedirect.set(true);
	  redirection.navigationListener.start();
	  redirection.tabChangeListener.start();
	  redirection.windowChangeListener.start();
	  redirection.addOriginTabCloseListener();
	}

	async function killAiki$1() {
	  const tabs = await browserPolyfill.tabs.query({
	    active: true,
	    currentWindow: true,
	  });
	  browserPolyfill.tabs.sendMessage(tabs[0].id, {
	    action: "kill aiki",
	  });
	  timer.stopLearningSession();
	  timer.stopBonusTime();
	  timer.killAiki();
	  badge.remove();
	  const user = await storage$1.uid.get();
	  firebase.addLog(
	    {
	      user: user,
	      event: "User toggled redirection off",
	      date: makeDate(),
	    },
	    "config"
	  );
	}

	async function reviveAiki() {
	  redirection.checkActiveTab();
	  const user = await storage$1.uid.get();
	  firebase.addLog(
	    {
	      user: user,
	      event: "User toggled redirection on",
	      date: makeDate(),
	    },
	    "config"
	  );
	}

	async function gotoOriginTab() {
	  const origin = await storage$1.origin.get();
	  browserPolyfill.tabs.update(origin.tabId, { selected: true });
	}

	/* Add listener for incomming communication from extension options page runtime and extension popup runetime 

	case "user" means the user added or removed a user ID. This requires the logger interval to be reset, 
	as the user value in the interval function is no longer correct. 

	case "list" means the user added or removed a procrastination website in settings page. 
	This requires the counting interval as well as the navigationListener need to be reset, 
	as these use the procrastination list.

	case "origin" is called by the popup runtime and means the tab that was used to open a procrastination website should
	return to the original procrastination website (ie. the user clicked "continue" or "Emergency skip")
	This also ends the injection listener.

	case "timer" is called by the popup runtime and returns the current time values 
	(ie. learning time remaining and extra time spent). */
	browserPolyfill.extension.onConnect.addListener(function (port) {
	  port.onMessage.addListener(function (msg) {
	    switch (msg.split(": ")[1]) {
	      case "user":
	        intervals.logger.restart();
	        break;
	      case "list":
	        intervals.counter.restart();
	        redirection.navigationListener.restart();
	        break;
	      case "origin":
	        redirection.gotoOrigin(msg.split(": ")[2], "popup");
	        redirection.removeLearningSiteLoadedListener();
	        break;
	      case "timer":
	        port.postMessage(timer.getTime());
	        break;
	      case "off":
	        killAiki$1();
	        break;
	      case "on":
	        reviveAiki();
	        break;
	      case "originTab":
	        gotoOriginTab();
	    }
	  });
	});

	/* Setup is run at each runtime creation (user opens the browser application) */
	setup();

}());
//# sourceMappingURL=background.js.map
